// $Id: HelloWorldApp.java 1705 2007-02-28 17:51:49Z mmcgann $

package edu.umiacs.gwt.hello.client;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;

public class HelloWorldApp implements EntryPoint
{
    Label lblSayHello = new Label();
    
    public void onModuleLoad()
    {
        edu.umiacs.gwt.util.GWTUtil.log("onModuleLoad()");
        
        Button btnAsk = new Button("Say something");
        btnAsk.addClickListener(new ClickListener()
        {
            public void onClick(Widget w)
            {
                lblSayHello.setText("...Asking Server...");
                retrieveMessageFromServer();
            }
        });
        
        VerticalPanel vp = new VerticalPanel();
        vp.add(btnAsk);
        vp.add(lblSayHello);
        
        RootPanel root = RootPanel.get("div1");
        root.add(vp);
    }
    
    private void retrieveMessageFromServer()
    {
        HelloWorldServiceAsync service = 
                (HelloWorldServiceAsync)GWT.create(HelloWorldService.class);

        ServiceDefTarget endpoint = (ServiceDefTarget)service;
        String moduleRelativeURL = GWT.getModuleBaseURL() + "hello-service";
        endpoint.setServiceEntryPoint(moduleRelativeURL);

        AsyncCallback callback = new AsyncCallback() 
        {
            public void onSuccess(Object result) 
            {
                String message = (String)result;
                lblSayHello.setText(message);
            }

            public void onFailure(Throwable caught) 
            {
                lblSayHello.setText("Error: " + caught.toString());
            }
        };

        service.doService(new ServiceRequest("Hello", '.'), callback);
    }
      
}
